"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CalendarUtil = {

  // calculate the end time for the meeting based on the duration so it's stored on
  // the scheduled meeting item, that way client can display start and end without
  // calculation on their side
  // gets the start time from server, and the duration, and reformats
  /**
   * calculates the end time for meeting
   * @param {Object} item the locus.host property
   * @param {Object} item.start start time of the meeting
   * @param {Object} item.duration duration of the meeting
   * @returns {Object} end time of the meeting
   * @memberof CalendarUtil
   */
  calculateEndTime: function calculateEndTime(item) {
    return (0, _extends3.default)({}, item, { endTime: new Date(new Date(item.start).getTime() + item.durationMinutes * 60000) });
  }
};

exports.default = CalendarUtil;
//# sourceMappingURL=util.js.map
